Scriptname DovahkiinAddArmorConc extends ActiveMagicEffect  

SPELL Property Invisibility  Auto  
SPELL Property StaggerSpell  Auto  

Perk Property PerkAdept  Auto  
Perk Property PerkMaster  Auto

MagicEffect Property AegisAdeptEffect  Auto  
MagicEffect Property AegisMasterEffect  Auto   

Actor Property Player Auto 
Actor Property AggActor Auto

EffectShader Property DetectLife  Auto 

Bool Property isDrain Auto 

ImageSpaceModifier property TrapImod auto
sound property TrapSoundFX auto ; create a sound property we'll point to in the editor
VisualEffect property TargetVFX auto
VisualEffect property CasterVFX auto
EffectShader property CasterFXS auto
EffectShader property TargetFXS auto

Event OnEffectStart(Actor akTarget, Actor akCaster)

	Player = Game.GetPlayer()

endEvent

Event OnHit(ObjectReference akAggressor, Form akSource, Projectile akProjectile, bool abPowerAttack, bool abSneakAttack, bool abBashAttack, bool abHitBlocked)

	DetectLife.Play(Player,2.0)

	if(Player.HasMagicEffect(AegisMasterEffect))
		If (Player.HasPerk(PerkMaster))
			Invisibility.Cast(Player)
		endIf
	endIf

	;If(abPowerAttack)
		;Debug.Notification("Power Attack!")
	;endIf

	;If(abBashAttack)
		;Debug.Notification("Bash Attack!")
	;endIf		

	AggActor = akAggressor as Actor

	int AggMag = AggActor.GetAV("Magicka") as int
	int AggStam = AggActor.GetAV("Stamina") as int
	int AggHealth = AggActor.GetAV("Health") as int

	Game.AdvanceSkill("restoration",5.0)

	isDrain = false

	Int AbsorbQty = 10

	If(Player.HasMagicEffect(AegisAdeptEffect))
		AbsorbQty = 20
	endIf
	
	If (Player.HasMagicEffect(AegisMasterEffect))
		AbsorbQty = 40
	endIf

	;Debug.Notification("AbsorbQty = " + AbsorbQty)

	If (AggMag >= AbsorbQty)

		AggActor.DamageActorValue("magicka", AbsorbQty)
		Player.RestoreActorValue("magicka", AbsorbQty)
		isDrain = true

	elseif (AggMag > 0)

		AggActor.DamageActorValue("magicka", AggMag)
		Player.RestoreActorValue("magicka", AggMag)
		isDrain = true

	endIf

	If (AggStam >= AbsorbQty)

		AggActor.DamageActorValue("stamina", AbsorbQty)
		Player.RestoreActorValue("stamina", AbsorbQty)
		isDrain = true
	
	elseif (AggStam > 0)

		AggActor.DamageActorValue("stamina", AggStam)
		Player.RestoreActorValue("stamina", AggStam)
		isDrain = true

	endIf

	If (AggHealth >= AbsorbQty)

		;AggActor.DamageActorValue("health", AbsorbQty)
		;Player.RestoreActorValue("health", AbsorbQty)
		;isDrain = true
	
	elseif (AggHealth > 0)

		;AggActor.DamageActorValue("health", AggHealth)
		;Player.RestoreActorValue("health", AggHealth)
		;isDrain = true

	endIf

	
	if(isDrain)

		Game.AdvanceSkill("destruction",1.0)

		if (!AggActor.IsInKillMove())

			If (Player.HasPerk(PerkAdept) || Player.HasPerk(PerkMaster))

				if(Player.HasMagicEffect(AegisAdeptEffect) || Player.HasMagicEffect(AegisMasterEffect ))
					;Debug.Notification("Staggered!")
					StaggerSpell.Cast(AggActor)
				endIf	

			else
				;Debug.Notification("No Stagger")
			endIf

			TrapSoundFX.play(Player)       					; play TrapSoundFX sound from player
			TrapImod.apply()  								; apply isMod at full strength
			TargetVFX.Play(AggActor,2.7,Player)  			; Play TargetVFX and aim them at the player
			CasterVFX.Play(Player,3.9,AggActor)
			TargetFXS.Play(AggActor,2) 					; Play Effect Shaders
			CasterFXS.Play(Player,3)

		endIf

	endIf

endEvent

Event  OnEffectFinish(Actor akTarget, Actor akCaster)
	

endEvent

  
